import { DataSync } from "@divinevoxel/core/Interfaces/World/Data/DataSync.js";
import { DataSyncNode } from "@divinevoxel/core/Interfaces/World/Data/DataSyncNode.js";
import type { LocationData } from "@divinevoxel/core/Math/index.js";
import type { WorldDataSync } from "../../Data/Types/DataSync.types.js";
import type { DimensionData } from "../../Data/Types/DimensionData.types.js";
import type { RemoteBinaryStructData } from "@amodx/binary/";
import { Chunk, Column, Region } from "../../Data/World/Classes/index.js";
export declare class DVEFDataSync extends DataSync {
    static instance: DVEFDataSync;
    constructor();
    worldDataTags: {
        chunk: DataSyncNode<void, RemoteBinaryStructData, void, false>;
        column: DataSyncNode<void, RemoteBinaryStructData, void, false>;
        region: DataSyncNode<void, [RemoteBinaryStructData, RemoteBinaryStructData], void, false>;
    };
    worldData: {
        dimesnion: DataSyncNode<string | number, DimensionData, string | number, boolean>;
        chunk: DataSyncNode<LocationData, [LocationData, Chunk], LocationData, LocationData>;
        column: DataSyncNode<LocationData, [LocationData, Column], LocationData, LocationData>;
        region: DataSyncNode<LocationData, [LocationData, Region], LocationData, LocationData>;
        regionHeader: DataSyncNode<LocationData, WorldDataSync, LocationData, boolean>;
    };
}
