import { DVEWorldCore } from "@divinevoxel/core/Interfaces/World/DVEWorldCore";
import { DVEFWorldThreads } from "./DVEFWorldThreads";
import { DVEFDataSync } from "./DVEFDataSync";
import { DVEFoundationTasksQueues } from "./Tasks/DVEFoundationTasksQueues";
import { DVEFDataReigster } from "./Data/DVEFDataRegister";
import { DVEFDataStructs } from "./Data/DVEFDataStructs";
import { WorldTasks } from "./Tasks/WorldTasks";
import { LocationData } from "@divinevoxel/core/Math";
export type DVEFWorldCoreProps = {
    nexusEnabled?: boolean;
    richWorldEnabled?: boolean;
    dataLoaderEnabled?: boolean;
};
export declare class DVEFWorldCore extends DVEWorldCore {
    props: DVEFWorldCoreProps;
    static instance: DVEFWorldCore;
    threads: DVEFWorldThreads;
    dataSync: DVEFDataSync;
    queues: DVEFoundationTasksQueues;
    dataRegiser: DVEFDataReigster;
    dataTagBulders: DVEFDataStructs;
    tasks: WorldTasks;
    constructor(props?: DVEFWorldCoreProps);
    init(): Promise<void>;
    removeColumnsOutsideRadius(origion: LocationData, radius: number): void;
}
