import { WorldThreadManager } from "@divinevoxel/core/Interfaces/World/Threads/WorldThreads";
import { DVEFWorldThreadState } from "./DVEFWorldThreadState";
import { Threads } from "@amodx/threads/";
export class DVEFWorldThreads extends WorldThreadManager {
    core;
    state;
    richWorld = Threads.createThread("rich-world");
    dataLoader = Threads.createThread("data-loader");
    nexus = Threads.createThread("nexus");
    constructor(core) {
        super();
        this.core = core;
        this.state = new DVEFWorldThreadState(this);
        if (core.props.nexusEnabled) {
            this.addThread(this.nexus);
        }
        if (core.props.dataLoaderEnabled) {
            this.addThread(this.dataLoader);
        }
        if (core.props.richWorldEnabled) {
            this.addThread(this.richWorld);
        }
    }
}
