import { BuildTasks, GenerateTasks, UpdateTasks, PriorityTask } from "../../../Types/Tasks.types";
import { DVEFWorldCore } from "../DVEFWorldCore";
import { QueueManager } from "@amodx/threads/Queue/QueueManager";
export declare class DVEFoundationTasksQueues {
    init(dve: DVEFWorldCore): void;
    _queueMap: Map<string | number, number>;
    addQueue(queueKey: string | number): boolean;
    removeQueue(queueKey: string | number): boolean;
    /**# Filter Queues
     * ---
     * Go through each current queue. IF the passed fucntion returns false it will remove that queue.
     * @param filter
     */
    filterQueues(filter: (queueKey: string | number) => boolean): void;
    /**# Filter Old Queues
     * ---
     * Will remove queues older then 10 minutes.
     * @param maxTime Max time in miliseconds.
     */
    filterOldQueues(maxTime?: number): void;
    worldSun: QueueManager<UpdateTasks>;
    propagation: QueueManager<UpdateTasks>;
    buildChunk: QueueManager<PriorityTask<BuildTasks>>;
    generate: QueueManager<GenerateTasks>;
    decorate: QueueManager<GenerateTasks>;
}
