;
//objects
import { Threads } from "@amodx/threads/";
import { WorldRegister } from "./World/WorldRegister.js";
import { DimensionsRegister } from "./World/DimensionsRegister.js";
import { RegionHeaderRegister, RegionHeaderTags, } from "./RegionHeaderRegister.js";
import { Column, Chunk, Region } from "./World/Classes/index.js";
import { DVEFDataSyncIds } from "./Constants/DVEFDataSyncIds.js";
import { RemoteDataSyncNode } from "@divinevoxel/core/Interfaces/Data/RemoteDataSyncNode.js";
export class DVEFDataSyncNode extends RemoteDataSyncNode {
    worldData = {
        dimension: Threads.onDataSync(DVEFDataSyncIds.Dimesnion, (data) => {
            DimensionsRegister.instance.registerDimension(data.id, data.options);
        }),
        chunk: Threads.onDataSync(DVEFDataSyncIds.Chunk, (data) => {
            WorldRegister.instance.chunk.add(data[0], data[1]);
        }, (data) => {
            WorldRegister.instance.chunk.remove(data);
        }),
        column: Threads.onDataSync(DVEFDataSyncIds.Column, (data) => {
            WorldRegister.instance.column.add(data[0], data[1]);
        }, (data) => {
            WorldRegister.instance.column.remove(data);
        }),
        region: Threads.onDataSync(DVEFDataSyncIds.Region, (data) => {
            WorldRegister.instance.region.add(data[0], data[1]);
        }, (data) => {
            WorldRegister.instance.region.remove(data);
        }),
        regionHeader: Threads.onDataSync(DVEFDataSyncIds.RegionHeader, (data) => {
            RegionHeaderRegister.add(data[0], data[1]);
        }, (data) => {
            RegionHeaderRegister.remove(data);
        }),
    };
    worldDataTags = {
        chunk: Threads.onDataSync(DVEFDataSyncIds.ChunkTags, (data) => {
            Chunk.StateStruct.init(data);
        }),
        column: Threads.onDataSync(DVEFDataSyncIds.ColumnTags, (data) => {
            Column.StateStruct.init(data);
        }),
        region: Threads.onDataSync(DVEFDataSyncIds.RegionTags, (data) => {
            Region.StateStruct.init(data[0]);
            RegionHeaderTags.init(data[1]);
        }),
    };
}
