import { Observable } from "@amodx/core/Observers/index.js";
import { AsyncPipeline, Pipeline } from "@amodx/core/Pipelines/";
import type { LocationData } from "@divinevoxel/core/Math/index.js";
import { DimensionData } from "./Types/DimensionData.types";
import { EngineSettingsData } from "@divinevoxel/core/Types/EngineSettings.types";
import { ChunkData, ColumnData, RegionData } from "./World/Classes/index.js";
export declare const DataHooks: {
    dimension: {
        onRegisterDimension: Pipeline<DimensionData>;
    };
    chunk: {
        onGetAsync: AsyncPipeline<{
            location: LocationData;
            chunk: ChunkData | null;
        }>;
        onGetSync: Pipeline<{
            location: LocationData;
            chunk: ChunkData | null;
        }>;
        onNew: Observable<LocationData>;
        onRemove: Observable<LocationData>;
    };
    column: {
        onGetAsync: AsyncPipeline<{
            location: LocationData;
            column: ColumnData | null;
        }>;
        onGetSync: Pipeline<{
            location: LocationData;
            column: ColumnData | null;
        }>;
        onNew: Observable<LocationData>;
        onRemove: Observable<LocationData>;
    };
    region: {
        onGetAsync: AsyncPipeline<{
            location: LocationData;
            region: RegionData | null;
        }>;
        onGetSync: Pipeline<{
            location: LocationData;
            region: RegionData | null;
        }>;
        onNew: Observable<LocationData>;
        onRemove: Observable<LocationData>;
    };
    paint: {
        onRichVoxelPaint: Observable<[id: string, location: LocationData]>;
    };
    settingsSynced: Observable<EngineSettingsData>;
};
