var StateMasks;
(function (StateMasks) {
    StateMasks[StateMasks["Level"] = 15] = "Level";
    StateMasks[StateMasks["LevelState"] = 48] = "LevelState";
    StateMasks[StateMasks["ShapeState"] = 65472] = "ShapeState";
})(StateMasks || (StateMasks = {}));
/**# Voxel Reader
 * ---
 * Used to decode voxel state data.
 */
export class VoxelStateReader {
    static getLevel(stateData) {
        return stateData & StateMasks.Level;
    }
    static setLevel(stateData, level) {
        return (stateData & ~StateMasks.Level) | level;
    }
    static getLevelState(stateData) {
        return (stateData & StateMasks.LevelState) >> 4;
    }
    static setLevelState(stateData, levelState) {
        return (stateData & ~StateMasks.LevelState) | (levelState << 4);
    }
    static getShapeState(voxelData) {
        return (voxelData & StateMasks.ShapeState) >> 6;
    }
    static setShapeState(voxelData, shapeState) {
        return (voxelData & ~StateMasks.ShapeState) | (shapeState << 6);
    }
}
