import { RemoteBinaryStruct } from "@amodx/binary/";
import { DVEMessageHeader, WorldDataHeaders, } from "../../Constants/DataHeaders.js";
export class Region {
    static CreateNew() {
        const stateBuffer = new SharedArrayBuffer(Region.StateStruct.structSize);
        Region.StateStruct.setBuffer(stateBuffer);
        Region.StateStruct.setProperty("#dve_header", DVEMessageHeader);
        Region.StateStruct.setProperty("#dve_data_type", WorldDataHeaders.region);
        return {
            stateBuffer,
            columns: {},
        };
    }
    static toObject(data) {
        return new Region(data);
    }
    static StateStruct = new RemoteBinaryStruct("region-tags");
    stateBuffer;
    columns = new Map();
    regionState;
    constructor(data) {
        this.regionState = new DataView(data.stateBuffer);
        this.stateBuffer = data.stateBuffer;
        const keys = Object.keys(data.columns);
        for (const key in keys) {
            data.columns[Number(key)] &&
                this.columns.set(Number(key), data.columns[Number(key)]);
        }
    }
    *getColumns() {
        for (const [key, column] of this.columns) {
            yield column;
        }
    }
    toJSON() {
        const columns = {};
        for (const [key, col] of this.columns) {
            columns[key] = col;
        }
        return {
            stateBuffer: this.stateBuffer,
            columns: columns,
        };
    }
}
