import { Chunk, Column } from "./Classes/index.js";
import { Flat3DIndex, Vector3Like } from "@amodx/math";
import { type LocationData } from "@divinevoxel/core/Math";
export declare class WorldRegisterCache {
    _cacheOn: boolean;
    _chunkCache: Map<number, Chunk>;
    _columnCache: Map<number, Column>;
    chunkSpaceIndex: Flat3DIndex;
    columnSpaceIndex: Flat3DIndex;
    worldSize: Vector3Like;
    chunkSize: Vector3Like;
    chunkSizePower: Vector3Like;
    columnSize: Vector3Like;
    columnSizePower: Vector3Like;
    constructor();
    symcSettings(): void;
    enable(): void;
    disable(): void;
    addChunk(key: number, data: Chunk): void;
    addColumn(key: number, data: Column): void;
    getChunk(key: number): Chunk | undefined;
    getColumn(key: number): Column | undefined;
    getChunkIndex(location: LocationData): number;
    getColumnIndex(location: LocationData): number;
    clear(): void;
}
