import type { AnaylzerTask } from "../../Types/Tasks.types.js";
import type { LocationData } from "@divinevoxel/core/Math";
import { DivineVoxelEngineConstructor } from "@divinevoxel/core/Contexts/Constructor/DivineVoxelEngineConstructor.js";
import { DVEAnaylzer } from "../../Interfaces/Anaylzer/DVEAnaylzer.js";
export declare class Analyzer extends DVEAnaylzer {
    updater: {
        _voxels: Map<string, (locaton: LocationData, deltaTime: number, anayzer: Analyzer, DVEC: DivineVoxelEngineConstructor) => void>;
        registerVoxel(id: string, run: (locaton: LocationData, deltaTime: number, anayzer: Analyzer, DVEC: DivineVoxelEngineConstructor) => void): void;
        getVoxel(id: string): false | ((locaton: LocationData, deltaTime: number, anayzer: Analyzer, DVEC: DivineVoxelEngineConstructor) => void);
    };
    processor: {
        columnTool: import("../Tools/Data/WorldData/ColumnDataTool.js").ColumnDataTool;
        chunkTool: import("../Tools/Data/WorldData/ChunkDataTool.js").ChunkDataTool;
        goThroughColumn<T>(location: LocationData, run: (x: number, y: number, z: number, column: import("../Tools/Data/WorldData/ColumnDataTool.js").ColumnDataTool) => void): void;
    };
    _flowChecks: number[][];
    runPropagation(data: AnaylzerTask): Promise<void>;
    runUpdate(data: AnaylzerTask): Promise<void>;
}
