import { TextureBuilder } from "./Meshers/TextureMesher.js";
import { VoxelBuilder } from "./Meshers/VoxelMesher.js";
export const MesherManager = {
    builders: new Map(),
    registerBuilder(builder) {
        this.builders.set(builder.id, builder);
    },
    buildNode(data) {
        const builder = this.builders.get(data[1]);
        if (!builder)
            return false;
        return builder.build(data);
    },
};
MesherManager.registerBuilder(TextureBuilder);
MesherManager.registerBuilder(VoxelBuilder);
