export class OverrideBase {
    voxels = new Map();
    register(voxel, override, run) {
        let voxelRules = this.voxels.get(voxel);
        if (!voxelRules) {
            voxelRules = new Map();
            this.voxels.set(voxel, voxelRules);
        }
        voxelRules.set(override, run);
    }
    run(voxel, override, data) {
        const voxelRules = this.voxels.get(voxel);
        if (!voxelRules)
            return data.default;
        const secondRule = voxelRules.get(override);
        if (!secondRule)
            return data.default;
        return secondRule(data);
    }
}
