import type { Vector3Like } from "@amodx/math";
import type { Size2D } from "@divinevoxel/core/Math";
import type { DirectionNames } from "@divinevoxel/core/Types";
import { QuadTransforms, QuadVertexes, TextureRotations } from "../Types/Geometry.types.js";
import { MesherDataTool } from "@amodx/meshing";
export declare class MeshBuilderTool {
    direction: DirectionNames;
    tool: MesherDataTool;
    constructor();
    setMesherTool(tool: MesherDataTool): this;
    quad: QuadBuilderTool;
}
export declare class QuadBuilderTool {
    tool: MesherDataTool;
    builder: any;
    uvs: QuadUVTool<this>;
    setMesherTool(tool: MesherDataTool): this;
    _fliped: boolean;
    _direction: DirectionNames;
    _position: Vector3Like;
    _cachedPosition: Vector3Like;
    _dimension: Size2D;
    _transform: QuadTransforms;
    setDimensions(width: number, height: number): this;
    setPosition(x?: number, y?: number, z?: number): this;
    updatePosition(x?: number, y?: number, z?: number): this;
    updatePositionInPlace(x?: number, y?: number, z?: number): this;
    setTransform(vertex: QuadVertexes, x?: number, y?: number, z?: number): this;
    clearTransform(): this;
    setFlipped(flipped: boolean): this;
    setDirection(direction: DirectionNames): this;
    create(): this;
    clear(): this;
}
export declare class QuadUVTool<T extends QuadBuilderTool> {
    quad: T;
    attributeId: string;
    uvs: any;
    _data: {
        width: number[];
        height: number[];
    };
    _fliped: boolean;
    advancedUVs: {
        hs1: number;
        hs2: number;
        he1: number;
        he2: number;
        ws1: number;
        ws2: number;
        we1: number;
        we2: number;
    };
    _rotation: TextureRotations;
    constructor(quad: T, attributeId: string);
    resetAdvancedUVs(): this;
    setFlipped(flipped: boolean): this;
    setWidth(start: number, end: number): this;
    setHeight(start: number, end: number): this;
    setRoation(rotation: TextureRotations): this;
    addAdvancedUVs(textureId: number): this;
    add(textureId: number): T;
    clear(): T;
}
