import type { FaceDataOverride } from "../Types/Override.types";
import { BuilderDataTool } from "./BuilderDataTool.js";
import { MesherDataTool } from "@amodx/meshing/Tools/MesherDataTools";
import { QuadScalarVertexData } from "@amodx/meshing/Classes/QuadVertexData";
import { VoxelTemplateDataTool } from "./VoxelTemplateDataTool.js";
import { VoxelFaces } from "@divinevoxel/core/Math";
export declare class VoxelMesherDataTool extends MesherDataTool {
    template: VoxelTemplateDataTool;
    voxel: BuilderDataTool;
    nVoxel: BuilderDataTool;
    faceDataOverride: FaceDataOverride;
    constructor();
    calculateLight(direction: VoxelFaces, ignoreAO?: boolean): void;
    calculateFlow(): void;
    getAnimationData(): QuadScalarVertexData;
    getWorldLight(): QuadScalarVertexData;
    getWorldAO(): QuadScalarVertexData;
    getWorldLevel(): QuadScalarVertexData;
    getOverlayTextures(): QuadScalarVertexData;
    setTexture(uv: number): this;
    getTexture(): number;
    setFaceFlipped(value: boolean): this;
    isFaceFlipped(): boolean;
    isFaceExposed(face: VoxelFaces): boolean;
}
