import { WorldDataTool } from "./WorldDataTool";
import { LocationData } from "@divinevoxel/core/Math";
import { DVEDataHandler } from "../../../Interfaces/DataLoader/DVEDataHandler";
import { WorldDataBase } from "./WorldDataBase";
export declare class DefaultDataHandler extends DVEDataHandler {
    static instance: DefaultDataHandler;
    worldDataTool: WorldDataTool;
    worldData: WorldDataBase;
    constructor();
    init(): Promise<void>;
    openWorldDataBae(id: string, dimension?: string): Promise<void>;
    getRegionHeader(location: LocationData): Promise<ArrayBuffer>;
    getColumn(location: LocationData): Promise<ArrayBufferLike>;
    saveColumn(location: LocationData, buffer: ArrayBuffer): Promise<boolean>;
    setPath(id: string): Promise<boolean>;
    columnExists(location: LocationData): Promise<boolean>;
    columnExistsBatch(location: LocationData[]): Promise<Record<string, boolean>>;
    columnTimestamp(location: LocationData): Promise<number>;
    columnHasSegment(location: LocationData, segment: "rich-data" | "dbo" | "entities"): Promise<boolean>;
}
