import { DVEDataHandler } from "../../../Interfaces/DataLoader/DVEDataHandler";
import { WorldDataBaseManager } from "./WorldDataBaseManager";
export class DefaultDataHandler extends DVEDataHandler {
    static instance;
    worldDataTool;
    worldData;
    constructor() {
        super();
        if (DefaultDataHandler.instance)
            return DefaultDataHandler.instance;
        DefaultDataHandler.instance = this;
    }
    async init() {
        await WorldDataBaseManager.init();
    }
    async openWorldDataBae(id, dimension = "main") {
        const worldDataBase = await WorldDataBaseManager.getWorldDataBase(id);
        await worldDataBase.setDimension(dimension);
        this.worldData = worldDataBase;
        this.worldDataTool = worldDataBase.worldDataTool;
    }
    async getRegionHeader(location) {
        this.worldDataTool.setType(this.dataType);
        return await this.worldDataTool.loadRegionHeader(location);
    }
    async getColumn(location) {
        this.worldDataTool.setType(this.dataType);
        return await this.worldDataTool.loadColumn(location);
    }
    async saveColumn(location, buffer) {
        this.worldDataTool.setType(this.dataType);
        return await this.worldDataTool.saveColumn(location, buffer);
    }
    async setPath(id) {
        this.worldDataTool.setType(this.dataType);
        return this.worldDataTool.setPath(id);
    }
    async columnExists(location) {
        this.worldDataTool.setType(this.dataType);
        return await this.worldDataTool.columnExists(location);
    }
    async columnExistsBatch(location) {
        this.worldDataTool.setType(this.dataType);
        return await this.worldDataTool.columnExistsBatch(location);
    }
    async columnTimestamp(location) {
        this.worldDataTool.setType(this.dataType);
        return await this.worldDataTool.columnTimestamp(location);
    }
    async columnHasSegment(location, segment) {
        this.worldDataTool.setType(segment);
        return await this.worldDataTool.columnExists(location);
    }
}
