import type { DataBase, ObjectStore } from "@amodx/indexdb/";
import type { DVEDDataTypes } from "../Types/DVED.types";
import { WorldDataTool } from "./WorldDataTool";
export declare class WorldDataBase {
    database: DataBase;
    dimension: string;
    typeStores: Record<DVEDDataTypes, ObjectStore<any>>;
    worldDataTool: WorldDataTool;
    constructor(database: DataBase);
    setDimension(dimensionId: string): Promise<void>;
    regionHeader: {
        set: (key: string, type: DVEDDataTypes, data: ArrayBuffer) => Promise<void>;
        get: (key: string, type: DVEDDataTypes) => Promise<ArrayBuffer | false>;
        getKey(key: string, type: DVEDDataTypes): string;
    };
    column: {
        set: (key: string, type: DVEDDataTypes, data: ArrayBuffer) => Promise<void>;
        get: (key: string, type: DVEDDataTypes) => Promise<false | ArrayBuffer>;
        getKey(key: string, type: DVEDDataTypes): string;
    };
    columnTimestamp: {
        set: (key: string, type: DVEDDataTypes, timeStamp: number) => Promise<void>;
        get: (key: string, type: DVEDDataTypes) => Promise<number | false>;
        getKey: (key: string, type: DVEDDataTypes) => string;
    };
}
