import { IndexDB } from "@amodx/indexdb/";
import { WorldDataBase } from "./WorldDataBase";
export class WorldDataBaseManager {
    static async init() {
        await IndexDB.init();
    }
    static async getWorldDataBase(dbName, dimension = "main") {
        let db;
        const existanceCheck = await IndexDB.databaseExists(dbName);
        if (!existanceCheck) {
            db = await IndexDB.createDatabase({
                databaseName: dbName,
                objectStores: [
                    {
                        name: "world-meta",
                        schema: [],
                    },
                ],
            });
            return new WorldDataBase(db);
        }
        else {
            db = await IndexDB.getDatabase(dbName);
            return new WorldDataBase(db);
        }
    }
    static async deleteWorldDataBase(dbName) {
        await IndexDB.deleteDatabase(dbName);
    }
}
