import type { ColumnData } from "../../../Data/World/Classes/Column.js";
import type { LocationData } from "@divinevoxel/core/Math";
import { RegionDataTool } from "../../Tools/Data/WorldData/RegionDataTool.js";
import { ColumnDataTool } from "../../Tools/Data/WorldData/ColumnDataTool.js";
import { ChunkDataTool } from "../../Tools/Data/WorldData/ChunkDataTool.js";
export declare class WorldDataSerializer {
    regions: RegionDataTool;
    columns: ColumnDataTool;
    chunks: ChunkDataTool;
    serializeRegion(location: LocationData): false | [location: LocationData, buffer: ArrayBuffer][];
    serializeColumn(location: LocationData): false | ArrayBuffer;
    deSerializeRegion(regionBuffers: ArrayBuffer[] | SharedArrayBuffer[]): void;
    deSerializeColumn(columnBuffer: ArrayBuffer | SharedArrayBuffer): ColumnData;
    _readDataIntoBuffer(offset: number, target: Uint8Array, source: ArrayBuffer | SharedArrayBuffer, sourceOffset?: number, sourceLength?: number): number;
}
