;
//objects
import { RegionDataTool } from "../../Tools/Data/WorldData/RegionDataTool.js";
import { ColumnDataTool } from "../../Tools/Data/WorldData/ColumnDataTool.js";
import { ChunkDataTool } from "../../Tools/Data/WorldData/ChunkDataTool.js";
import { BinaryObject } from "@amodx/binary";
export class WorldDataSerializer {
    regions = new RegionDataTool();
    columns = new ColumnDataTool();
    chunks = new ChunkDataTool();
    serializeRegion(location) {
        if (!this.regions
            .setDimension(location[0])
            .loadInAt(location[1], location[2], location[3]))
            return false;
        const region = this.regions.getRegion();
        const columnBuffers = [];
        region.columns.forEach((column) => {
            this.columns.setColumn(column);
            const location = this.columns.getLocationData();
            const columnBuffer = this.serializeColumn(location);
            if (columnBuffer)
                columnBuffers.push([[...location], columnBuffer]);
        });
        return columnBuffers;
    }
    serializeColumn(location) {
        if (!this.columns.setLocation(location).loadIn())
            return false;
        const column = this.columns.getColumn();
        const columnData = column.toJSON();
        const columnArray = BinaryObject.objectToBuffer(columnData);
        return columnArray;
    }
    deSerializeRegion(regionBuffers) {
        for (const buffer of regionBuffers) {
            this.deSerializeColumn(buffer);
        }
    }
    deSerializeColumn(columnBuffer) {
        BinaryObject.setUseSharedMemory(true);
        const columnData = BinaryObject.bufferToObject(columnBuffer);
        BinaryObject.setUseSharedMemory(false);
        return columnData;
    }
    _readDataIntoBuffer(offset, target, source, sourceOffset = 0, sourceLength = -1) {
        const bufferArray = new Uint8Array(source, sourceOffset, sourceLength == -1 ? source.byteLength : sourceLength);
        let i = bufferArray.length;
        while (i--) {
            target[i + offset] = bufferArray[i];
        }
        return bufferArray.length;
    }
}
