import type * as FileSystem from "fs";
import { NodeRegionTool } from "./Tools/NodeRegionTool.js";
import { VoxelSpaces } from "@divinevoxel/core/Math/Spaces/VoxelSpaces.js";
import { BinaryStruct } from "@amodx/binary/";
type Vector3 = {
    x: number;
    y: number;
    z: number;
};
export declare const DVED: {
    spaces: VoxelSpaces;
    regionTags: BinaryStruct;
    system: {
        fs: typeof FileSystem;
        $INIT(fs: typeof FileSystem): void;
        updateFolder(folder: string): void;
        mkdirs(paths: string[]): void;
        sync: {
            createFile(path: string, size?: number, mode?: number): boolean;
            createAndOpenFile(path: string, size?: number): false | import("../Types/DVED.types.js").DVEDSyncFile;
            openFile(filePath: string, showErrors?: boolean): import("../Types/DVED.types.js").DVEDSyncFile | false;
        };
    };
    path: {
        _dataPath: string;
        _dataFolder: string;
        _folder: string;
        _tempPath: string;
        setFolder(folder: string): void;
        getDataPath(): string;
        getDataDirectory(fileName?: string): string;
        getDirecoty(fileName?: string): string;
        getTempPath(fileName?: string): string;
        $INIT(): void;
    };
    $INIT(data: {
        fs: typeof FileSystem;
        dataDirecotry: string;
        sectorSize: number;
        spaceBounds: {
            regions: Vector3;
            columns: Vector3;
            chunks: Vector3;
        };
    }): void;
    getRegionTool(): NodeRegionTool;
};
export {};
