import type { LocationData } from "@divinevoxel/core/Math";
import { DVEDataHandler, DataLoaderModes } from "../../../Interfaces/DataLoader/DVEDataHandler.js";
import { RichDataTool } from "../../Tools/Data/RichDataTool.js";
import { ColumnDataTool } from "../../Tools/Data/WorldData/ColumnDataTool.js";
import { DataSerializerTool } from "./Tools/DataSerializerTool.js";
export declare class DataHanlderWrapper {
    static instance: DataHanlderWrapper;
    columnDatatool: ColumnDataTool;
    static mode: DataLoaderModes;
    handler: DVEDataHandler;
    richData: RichDataTool;
    seralizer: DataSerializerTool;
    constructor();
    init(handler: DVEDataHandler): void;
    loadRegionHeader(location: LocationData): Promise<boolean>;
    saveColumn(location: LocationData): Promise<boolean | undefined>;
    loadColumn(location: LocationData): Promise<boolean>;
    unLoadColumn(location: LocationData): Promise<true | undefined>;
    setPath(id: string): Promise<boolean>;
    columnExists(location: LocationData): Promise<boolean>;
    columnExistsBatch(location: LocationData[]): Promise<false | Record<string, boolean>>;
    columnTimestamp(location: LocationData): Promise<number>;
}
