import type { LocationData } from "@divinevoxel/core/Math";
import { ColumnDataTool } from "../../../Tools/Data/WorldData/ColumnDataTool.js";
export declare class DataLoaderTool {
    static columnDataTool: ColumnDataTool;
    dimension: string;
    mode: "indexdb" | "server" | "both";
    _enabled: boolean;
    constructor();
    setDimension(dimension: string): void;
    isEnabled(): boolean;
    saveColumnIfNotStored(location: LocationData): Promise<boolean>;
    loadIfExists(location: LocationData): Promise<boolean>;
    saveColumn(location: LocationData): Promise<void>;
    loadColumn(location: LocationData): Promise<void>;
    unLoadColumn(location: LocationData): Promise<false | undefined>;
    columnExists(location: LocationData): Promise<boolean>;
    columnExistsBatch(location: LocationData[]): Promise<false | Record<string, boolean>>;
    columnTimestamp(location: LocationData): Promise<number>;
    unLoadAllOutsideRadius([, sx, , sz]: LocationData, radius: number, run?: (column: ColumnDataTool) => boolean): Promise<void>;
    unLoadAllColumns(onDone?: Function): Promise<void>;
    allColumns(run: (column: ColumnDataTool) => void): void;
    allColumnsAsync(run: (column: ColumnDataTool) => Promise<void>): Promise<void>;
    getAllUnStoredColumns(run: (dimension: string, x: number, y: number, z: number) => void): void;
}
