import type { LocationData } from "@divinevoxel/core/math";
import { ThreadPool } from "@amodx/threads/";
import { ColumnDataTool } from "../../../Tools/Data/WorldData/ColumnDataTool.js";
import { LocationBoundTool } from "../../../Tools/Classes/LocationBoundTool.js";
import { SafePromise } from "@amodx/core/Promises/SafePromise.js";
export declare class DataLoaderTool extends LocationBoundTool {
    static columnDataTool: ColumnDataTool;
    static isEnabled(): boolean;
    mode: "indexdb" | "server" | "both";
    _enabled: boolean;
    dataComm: ThreadPool;
    constructor();
    _runTask(id: string, location: LocationData, onDone?: Function): void;
    isEnabled(): boolean;
    saveRegion(onDone?: Function): void;
    saveRegionAsync(): SafePromise<any>;
    loadRegion(onDone?: Function): void;
    loadRegionAsync(): SafePromise<any>;
    saveColumn(onDone?: Function): void;
    saveColumnIfNotStored(onDone?: (saved: boolean) => void): boolean | void;
    loadIfExists(onDone?: (loaded: boolean) => void): false | void;
    saveColumnAsync(): Promise<any>;
    loadColumn(onDone?: Function): void;
    loadColumnAsync(): Promise<any>;
    unLoadColumn(onDone: (done: boolean) => void): false | void;
    columnExists(onDone?: (exists: boolean) => void): void;
    loadRegionHeader(onDone?: (success: boolean) => void): void;
    loadRegionHeaderAsync(): Promise<any>;
    columnExistsAsync(): Promise<boolean>;
    columnTimestamp(onDone?: (timestamp: number) => void): void;
    columnTimestampAsync(): Promise<number>;
    unLoadAllOutsideRadius(radius: number, run?: (column: ColumnDataTool) => boolean, onDone?: Function): void;
    unLoadAllColumnsAsync(): Promise<any>;
    unLoadAllColumns(onDone?: Function): void;
    allColumns(run: (column: ColumnDataTool) => void): void;
    getAllUnStoredColumns(run: (dimension: string, x: number, y: number, z: number) => void): void;
}
