import { WorldSpaces } from "@divinevoxel/core/Data/World/WorldSpaces";
export class DebouncedTasks {
    data;
    _tasks = new Map();
    constructor(data) {
        this.data = data;
    }
    runTasksNow([dimension, cx, cy, cz]) {
        this.data.run([dimension, cx, cy, cz]);
    }
    runTasks([dimension, cx, cy, cz]) {
        const columnKey = WorldSpaces.column.getKeyXYZ(cx, 0, cz);
        if (this._tasks.has(columnKey)) {
            clearTimeout(this._tasks.get(columnKey));
        }
        this._tasks.set(columnKey, setTimeout(() => {
            this.data.run([dimension, cx, cy, cz]);
        }, this.data.timeOut));
    }
    clearTasks([dimension, cx, cy, cz]) {
        const columnKey = WorldSpaces.column.getKeyXYZ(cx, 0, cz);
        if (this._tasks.has(columnKey)) {
            clearTimeout(this._tasks.get(columnKey));
            this._tasks.delete(columnKey);
        }
    }
    hasTasks(key) {
        return this._tasks.has(key);
    }
    hasTasksLocation([dimension, cx, cy, cz]) {
        const columnKey = WorldSpaces.column.getKeyXYZ(cx, 0, cz);
        return this._tasks.has(columnKey);
    }
}
