import { IWGGeneratorData, IWGSettignsData, IWGTasksTypes } from "../Types/IWG.types";
import { Vec3Array } from "@amodx/math";
import { ColumnDataTool } from "../../../Tools/Data/WorldData/ColumnDataTool.js";
import { BuilderTool } from "../../../Tools/Build/BuilderTool.js";
import { TaskTool } from "../../../Tools/Tasks/TasksTool.js";
import { DataLoaderTool } from "../../../DataLoader/World/Tools/DataLoaderTool.js";
import { AnaylzerTool } from "../../../Tools/Anaylzer/AnaylzerTool.js";
import { IWGTaskBase } from "./Tasks/IWGTaskBase.js";
import { RichDataTool } from "../../../Tools/Data/RichDataTool.js";
import { LocationBoundTool } from "../../../Tools/Classes/LocationBoundTool.js";
/**# Infinite World Generator
 *
 */
export declare class Generator extends LocationBoundTool {
    data: IWGGeneratorData;
    _anaylzerDone: boolean;
    anaylzer: AnaylzerTool;
    columnTool: ColumnDataTool;
    nColumnTool: ColumnDataTool;
    builder: BuilderTool;
    dataLoader: DataLoaderTool | null;
    richData: RichDataTool;
    dveTasks: TaskTool;
    _cachedPosition: Vec3Array;
    _cachedVelocity: Vec3Array;
    __build: boolean;
    _visitedMap: Map<string, boolean>;
    _builtColumns: Map<string, number[]>;
    private columnSquare;
    private genCircle;
    private renderCircle;
    private maxCircle;
    tasks: Record<IWGTasksTypes, Map<string, IWGTaskBase>>;
    constructor(data: IWGGeneratorData);
    setDimension(dimensionId: string): this;
    updateDimension(dimension: string): this;
    clearAll(): void;
    saveUpdate(max?: number): void;
    saveAllColumns(): void;
    unLoadAllColumns(): void;
    _logTasks(): string;
    anaylzerUpdate(): void;
    worldGenUpdate(max?: number): void;
    renderTaskUpdate(max?: number): void;
    cancelWorldGenTasks(): void;
    cancelAllRenderTask(): void;
    updateSettings(settings: IWGSettignsData): void;
    private cullColumns;
    private getColumnState;
    generateUpdate(): void;
    renderUpdate(): void;
}
