import { Vec3ArrayDistanceSort } from "@divinevoxel/core/Math/Functions/DistnaceSort.js";
import { IWG } from "../../IWG.js";
import { IWGTaskBase } from "./IWGTaskBase";
export class IWGBatchTask extends IWGTaskBase {
    runTasks(max = 5, cachedPosition) {
        if (this.waitingFor < 0)
            this.waitingFor = 0;
        if (this.waitingFor >= max)
            return;
        Vec3ArrayDistanceSort(cachedPosition, this.queue);
        const batch = [];
        while (this.waitingFor < max) {
            const node = this.queue.shift();
            if (!node)
                break;
            this.waitingFor++;
            const [x, y, z] = node;
            if (this.getMeta().propagationBlocking) {
                IWG.inProgressMap.add(x, y, z, this.getMeta().id);
            }
            batch.push([this.gen.dimension, x, y, z]);
        }
        if (!batch.length)
            return;
        this.run(batch, () => {
            for (const [, x, y, z] of batch) {
                this.map.remove(x, y, z);
                if (this.getMeta().propagationBlocking) {
                    IWG.inProgressMap.remove(x, y, z);
                }
            }
            this.waitingFor = 0;
        });
    }
}
