import { Vec3ArrayDistanceSort } from "@divinevoxel/core/Math/Functions/DistnaceSort.js";
import { IWG } from "../../IWG.js";
import { IWGTaskBase } from "./IWGTaskBase";
export class IWGSingleTask extends IWGTaskBase {
    runTasks(max = 5, cachedPosition) {
        if (this.waitingFor < 0)
            this.waitingFor = 0;
        if (this.waitingFor >= max)
            return;
        Vec3ArrayDistanceSort(cachedPosition, this.queue);
        while (this.waitingFor < max) {
            const node = this.queue.shift();
            if (!node)
                break;
            this.waitingFor++;
            const [x, y, z] = node;
            if (this.getMeta().propagationBlocking) {
                IWG.inProgressMap.add(x, y, z, this.getMeta().id);
            }
            this.run(this.gen.dimension, x, y, z, () => {
                this.map.remove(x, y, z);
                if (this.getMeta().propagationBlocking) {
                    IWG.inProgressMap.remove(x, y, z);
                }
                this.waitingFor--;
            });
        }
    }
}
