import type { IWGTasksTypes } from "../../Types/IWG.types";
import { Generator } from "../Generator.js";
import { VisitedMap } from "../../../../../Util/VisistedMap.js";
import { Vec3Array } from "@amodx/math";
export type IWGTasksData = {
    id: string;
    name: string;
    type: IWGTasksTypes;
    propagationBlocking?: boolean;
};
export interface IWGTaskBaseInterface {
    Data: IWGTasksData;
    new (gen: Generator): IWGTaskBase;
}
export declare abstract class IWGTaskBase {
    gen: Generator;
    queue: [x: number, y: number, z: number][];
    map: VisitedMap;
    waitingFor: number;
    constructor(gen: Generator);
    add(x: number, y: number, z: number): void;
    remove(x: number, y: number, z: number): void;
    cancelAll(): void;
    abstract runTasks(max: number, cachedPosition: Vec3Array): void;
    abstract getMeta(): IWGTasksData;
    abstract getClass(): IWGTaskBaseInterface;
}
