import { IWG } from "../../IWG.js";
import { VisitedMap } from "../../../../../Util/VisistedMap.js";
export class IWGTaskBase {
    gen;
    queue = [];
    map = new VisitedMap();
    waitingFor = 0;
    constructor(gen) {
        this.gen = gen;
    }
    add(x, y, z) {
        if (this.map.inMap(x, y, z))
            return;
        if (this.getMeta().propagationBlocking && IWG.inProgressMap.has(x, y, z))
            return;
        this.queue.push([x, y, z]);
        this.map.add(x, y, z);
    }
    remove(x, y, z) {
        this.map.remove(x, y, z);
        if (this.getMeta().propagationBlocking) {
            IWG.inProgressMap.remove(x, y, z);
        }
    }
    cancelAll() {
        if (this.getMeta().type == "world-gen") {
            while (this.queue.length) {
                const node = this.queue.shift();
            }
        }
        this.queue = [];
        this.map.clear();
    }
}
