import { IWGGeneratorData, IWGSettignsData } from "./Types/IWG.types";
import { Generator } from "./Classes/Generator.js";
import { LocationData } from "@divinevoxel/core/Math";
export declare class IWG {
    static inProgressMap: {
        map: Map<string, string>;
        add(x: number, y: number, z: number, tasks: string): void;
        has(x: number, y: number, z: number): boolean;
        remove(x: number, y: number, z: number): boolean;
    };
    static getKey(x: number, y: number, z: number): string;
    static generators: Map<string, Generator>;
    static addGenerator(data: IWGGeneratorData): Generator;
    static getGenerator(id: string): false | Generator;
    static removeGenerator(id: string): boolean;
    static worldGenUpdate(max?: number): void;
    static searchUpdate(): void;
    static saveUpdate(max?: number): void;
    static initalLoad(dimension: string, position: number[] | Float32Array | Float64Array | Int32Array | Int16Array, settings?: IWGSettignsData, onCheck?: (gen: Generator) => void): Promise<void>;
    static safeExit(genId: string, onCheck?: (gen: Generator) => void): Promise<false | undefined>;
    static teleport(genId: string, location: LocationData, onCheck?: (gen: Generator) => void): Promise<false | undefined>;
}
