import type { Generator } from "../Classes/Generator";
import type { IWGTasksTypes } from "../Types/IWG.types";
export declare abstract class IWGLoadBase {
    gen: Generator;
    settings: {
        doWorldGenUpdate: boolean;
        doSaveUpate: boolean;
        doBuildUpdate: boolean;
        timeout: number;
    };
    constructor(gen: Generator);
    _getTotalTasks(types: IWGTasksTypes[]): number;
    _getTotalInProgress(types: IWGTasksTypes[]): number;
    _waitTillAllTasksAreDone(type: IWGTasksTypes[], onCheck?: Function): Promise<unknown>;
    abstract run(onCheck: (gen: Generator) => void): Promise<void>;
}
