import { IWGSingleTask } from "../../Classes/Tasks/IWGSingleTask";
import { IWG } from "../../IWG";
import { IWGTasksTypes } from "../../Types/IWG.types";
export class IWGBuildTasks extends IWGSingleTask {
    static Data = {
        id: "#dve_iwg_build",
        name: "build",
        type: IWGTasksTypes.Rendering,
    };
    getMeta() {
        return this.getClass().Data;
    }
    getClass() {
        return IWGBuildTasks;
    }
    async run(dimensionId, x, y, z, onDone) {
        const gen = this.gen;
        gen._builtColumns.set(IWG.getKey(x, y, z), [x, y, z]);
        gen.builder
            .setDimension(gen.dimension)
            .setXYZ(x, y, z)
            .buildColumn((data) => {
            onDone();
        });
    }
}
