import { IWGSingleTask } from "../../Classes/Tasks/IWGSingleTask";
import { IWGTasksTypes } from "../../Types/IWG.types";
export class IWGSaveAndUnloadTasks extends IWGSingleTask {
    static Data = {
        id: "#dve_iwg_save_and_unload",
        name: "save and unload",
        type: IWGTasksTypes.Saving,
    };
    getMeta() {
        return this.getClass().Data;
    }
    getClass() {
        return IWGSaveAndUnloadTasks;
    }
    async run(dimensionId, x, y, z, onDone) {
        const gen = this.gen;
        if (!gen.dataLoader)
            return onDone();
        gen.dataLoader.unLoadColumn([gen.dimension, x, y, z]);
        await onDone();
    }
}
