import { IWGSingleTask } from "../../Classes/Tasks/IWGSingleTask";
import { IWGTasksTypes } from "../../Types/IWG.types";
export class IWGSaveTasks extends IWGSingleTask {
    static Data = {
        id: "#dve_iwg_save",
        name: "save",
        type: IWGTasksTypes.Saving,
    };
    getMeta() {
        return this.getClass().Data;
    }
    getClass() {
        return IWGSaveTasks;
    }
    async run(dimensionId, x, y, z, onDone) {
        const gen = this.gen;
        if (!gen.dataLoader)
            return onDone();
        await gen.dataLoader.saveColumnIfNotStored([gen.dimension, x, y, z]);
        onDone();
    }
}
