import { IWGSingleTask } from "../../Classes/Tasks/IWGSingleTask";
import { IWGTasksTypes } from "../../Types/IWG.types";
export class IWGPropagationTasks extends IWGSingleTask {
    static Data = {
        id: "#dve_iwg_propagation",
        name: "propagation",
        type: IWGTasksTypes.WorldGen,
        propagationBlocking: true,
    };
    getMeta() {
        return this.getClass().Data;
    }
    getClass() {
        return IWGPropagationTasks;
    }
    async run(dimensionId, x, y, z, onDone) {
        const gen = this.gen;
        if (gen.columnTool.loadInAt(x, y, z) &&
            gen.columnTool.getStructValue("#dve_is_world_propagation_done"))
            return onDone();
        gen.dveTasks.propagation.deferred.run([gen.dimension, x, y, z], () => {
            onDone();
            if (gen.columnTool.loadInAt(x, y, z))
                return gen.columnTool.setTagValue("#dve_is_world_propagation_done", 1);
        });
    }
}
