import type { Vector3Like, Vec3Array } from "@amodx/math";
import { Vector3 } from "@divinevoxel/core/Math/Classes/Vector3.js";
export declare class BoundingBox {
    bounds: {
        minX: number;
        maxX: number;
        minZ: number;
        maxZ: number;
        minY: number;
        maxY: number;
    };
    _full: {
        w: number;
        h: number;
        d: number;
    };
    _half: {
        w: number;
        h: number;
        d: number;
    };
    position: Vector3;
    constructor(width?: number, height?: number, depth?: number);
    update(width: number, height: number, depth: number): void;
    setPosition(position: Vector3): void;
    get width(): number;
    get height(): number;
    get depth(): number;
    set width(width: number);
    set height(height: number);
    set depth(depth: number);
    get halfWidth(): number;
    get halfHeight(): number;
    get halfDepth(): number;
    pointIsInside(point: Vector3Like): boolean;
    doesIntersect(boundingBox: BoundingBox): boolean;
    query(): Generator<Vec3Array>;
}
