import { PhysicsDataTool } from "./Tools/Data/PhysicsDataTool.js";
export declare const DVP: {
    math: {
        visitAll: (startPoint: import("@amodx/math").Vector3Like, endPoint: import("@amodx/math").Vector3Like, visitor?: (x: number, y: number, z: number) => boolean) => number[];
        getVector3(x: number, y: number, z: number): import("@divinevoxel/core/Math/index.js").Vector3;
        getPlane(pv1: import("@divinevoxel/core/Math/index.js").Vector3, pv2: import("@divinevoxel/core/Math/index.js").Vector3, pv3: import("@divinevoxel/core/Math/index.js").Vector3, pv4: import("@divinevoxel/core/Math/index.js").Vector3): import("@divinevoxel/core/Math/index.js").Plane;
        getSimpleBoundingBox(origin: import("@divinevoxel/core/Math/index.js").Vector3, dimensions: import("@divinevoxel/core/Math/Math.types.js").VolumeDimensions): import("@divinevoxel/core/Math/index.js").SimpleBoundingBox;
        getBoundingBox(data: import("@divinevoxel/core/Math/index.js").BoundingBoxData): import("@divinevoxel/core/Math/index.js").BoundingBox;
        convertToOriginGridSpace(position: number[]): number[];
        distance2D(x1: number, x2: number, y1: number, y2: number): number;
        distance3D(x1: number, y1: number, z1: number, x2: number, y2: number, z2: number): number;
    };
    collisions: {
        readonly COLLISION_CHECK_POSITION_OFFSET: number;
        aabb: {
            start: import("@divinevoxel/core/Math/index.js").Vector3;
            delta: import("@divinevoxel/core/Math/index.js").Vector3;
            results: import("./Classes/CollisionResult.js").CollisionResult;
            line: import("./Classes/Line.js").Line;
            plane: import("./Classes/Plane.js").Plane;
            dimensions: import("@divinevoxel/core/Math/index.js").Vector3;
        };
        sweepAABBN(physicsNodePosition: import("@divinevoxel/core/Math/index.js").Vector3, boundingBox: import("./Classes/BoundingBox.js").BoundingBox, collisionNode: import("./Classes/CollisionNode.js").CollisionNode, velocity: import("@divinevoxel/core/Math/index.js").Vector3): {
            hitDepth: number;
            nx: number;
            ny: number;
            nz: number;
        };
        between(x: number, a: number, b: number): boolean;
        processSwpetAABB(node: import("./Nodes/PhysicsNodes.js").PhysicsNode): void;
    };
    colliders: {
        colliders: Record<string, import("./Classes/Collider.js").Collider>;
        registerCollider(collider: import("./Classes/Collider.js").Collider | import("./Classes/Collider.js").Collider[]): void;
        getCollider(id: string): import("./Classes/Collider.js").Collider;
    };
    constants: {
        flags: {
            climbable: string;
        };
    };
    getDataTool(): PhysicsDataTool;
};
export type DivineVoxelEnginePhysics = typeof DVP;
