import { Vector3 } from "@divinevoxel/core/Math/Classes/Vector3.js";
import { PhysicsDataTool } from "../Tools/Data/PhysicsDataTool.js";
import { Vector3Like } from "@amodx/math";
import { LocationData } from "@divinevoxel/core/Math/";
import { BoundingBox } from "../Classes/BoundingBox.js";
import type { Collider } from "../Classes/Collider.js";
import { CollisionNode } from "../Classes/CollisionNode.js";
import { PhysicsProbe } from "../Tools/Data/PhysicsProbe.js";
type ColliderHanlder = (collider: Collider, colisionNode: CollisionNode, dataTool: PhysicsDataTool) => void;
/**# Physics Node
 * Holds the most basic information for a physics based object.
 *
 */
export declare class PhysicsNode {
    __previousPosiiton: Vector3;
    __delta: Vector3;
    acceleration: Vector3;
    velocity: Vector3;
    position: Vector3;
    direction: Vector3;
    delta: Vector3;
    boundingBox: BoundingBox;
    probe: PhysicsProbe;
    dataTool: PhysicsDataTool;
    doCollision: ColliderHanlder;
    setCollisionHanlder(handler: ColliderHanlder): void;
    setLocation(location: LocationData): void;
    setPosition(x: number, y: number, z: number): void;
    syncPosition(position: Vector3Like): void;
    applyForces(): void;
    calculateFinalDirection(forwardDirection: Vector3, sideDirection: Vector3): void;
}
export {};
