import { DataTool } from "../../Tools/Data/DataTool.js";
import { BrushTool } from "../../Tools/Brush/Brush.js";
import type { FlowTaskRequests } from "../../../Contexts/Constructor/Tasks/TasksRequest.js";
import { SubstanceDataTool } from "../../Tools/Data/SubstanceDataTool.js";
export declare class FlowManager {
    static lightData: {
        SRS: number;
        _lightValues: [s: number, r: number, g: number, b: number];
        getS(value: number): number;
        getR(value: number): number;
        getG(value: number): number;
        getB(value: number): number;
        setS(value: number, sl: number): number;
        setR(value: number, sl: number): number;
        setG(value: number, sl: number): number;
        setB(value: number, sl: number): number;
        removeS(sl: number): number;
        hasRGBLight(sl: number): boolean;
        hasSunLight(sl: number): boolean;
        mixLight(l1: number, l2: number): number;
        getRGB(sl: number): number;
        setRGB(value: number, sl: number): number;
        decodeLightFromVoxelData(voxelData: number): number;
        encodeLightIntoVoxelData(voxelData: number, encodedLight: number): number;
        setLightValues(values: number[]): number;
        getLightValues(value: number): [s: number, r: number, g: number, b: number];
        isLessThanForRGBRemove(n1: number, n2: number): boolean;
        isLessThanForRGBAdd(n1: number, n2: number): boolean;
        isGreaterOrEqualThanForRGBRemove(n1: number, n2: number): boolean;
        getMinusOneForRGB(sl: number, nl: number): number;
        removeRGBLight(sl: number): number;
        getFullSunLight(sl: number): number;
        isLessThanForSunAdd(n1: number, n2: number): boolean;
        isLessThanForSunAddDown(n1: number, n2: number): boolean;
        isLessThanForSunAddUp(n1: number, n2: number): boolean;
        getSunLightForUnderVoxel(sl: number, nl: number): number;
        getMinusOneForSun(sl: number, nl: number): number;
        isLessThanForSunRemove(n1: number, sl: number): boolean;
        isGreaterOrEqualThanForSunRemove(n1: number, sl: number): boolean;
        sunLightCompareForDownSunRemove(n1: number, sl: number): boolean;
        removeSunLight(sl: number): number;
        minusOneForAll(sl: number): number;
        addLightValues(sl: number, sl2: number): number;
        divideLightValue(sl: number, divisor: number): number;
    };
    static _brush: BrushTool;
    static _sDataTool: DataTool;
    static _nDataTool: DataTool;
    static _substanceTool: SubstanceDataTool;
    static setVoxel(tasks: FlowTaskRequests, vox: string, level: number, levelState: number, x: number, y: number, z: number): void;
    static setDimension(dimension: string): void;
    static removeVoxel(tasks: FlowTaskRequests, x: number, y: number, z: number): void;
    static getFlowRate(substance: string): number;
    static getVoxel(x: number, y: number, z: number): false | DataTool;
    static setLevel(level: number, x: number, y: number, z: number): void;
    static getLevel(vox: string, x: number, y: number, z: number): number;
    static getLevelState(vox: string, x: number, y: number, z: number): number;
    static canFlowOutwardTest(vox: string, x: number, y: number, z: number): boolean;
    static flowDownTest(vox: string, x: number, y: number, z: number): boolean;
    static wait(ms: number): Promise<unknown>;
    static _lightValues: [s: number, r: number, g: number, b: number];
    static getAbsorbLight(x: number, y: number, z: number): number;
    static sunCheck(tasks: FlowTaskRequests, x: number, y: number, z: number): void;
}
