import { RGBRemove, RGBUpdate } from "./Illumanation/Functions/RGBUpdate.js";
import { SunRemove, SunUpdate } from "./Illumanation/Functions/SunUpdate.js";
import { RunWorldSun } from "./Illumanation/Functions/WorldSun.js";
import { FlowUpdate } from "./Flow/Functions/FlowUpdate.js";
import { FlowRemove } from "./Flow/Functions/FlowRemove.js";
import { ExplosionManager } from "./Explosion/ExplosionManager.js";
import { DVEPropagation } from "../../Interfaces/Propagation/DVEPropagation.js";
export class Propagation extends DVEPropagation {
    explosion(tasks) {
        ExplosionManager.runExplosion(tasks);
    }
    async flowUpdate(tasks, rebuild = true) {
        await FlowUpdate(tasks, rebuild);
    }
    async flowRemove(tasks, rebuild = true) {
        await FlowRemove(tasks);
    }
    worldSun(tasks) {
        RunWorldSun(tasks);
    }
    rgbUpdate(tasks) {
        RGBUpdate(tasks);
    }
    rgbRemove(tasks) {
        RGBRemove(tasks);
    }
    sunUpdate(tasks) {
        SunUpdate(tasks);
    }
    sunRemove(tasks, clearUpdateMap = false) {
        SunRemove(tasks, clearUpdateMap);
    }
}
