import { URIShader } from "@amodx/uri/Shaders/Classes/URIShader.js";
import { UtilMap } from "../../Util/UtilMap.js";
export declare class DVEShaderRegister {
    shaders: UtilMap<string, URIShader>;
    create(shaders: URIShader[]): void;
    get(id: string): URIShader | undefined;
    getBulder(): {
        shaders: {
            _shaders: Map<string, URIShader>;
            create(id: string): URIShader;
        };
        functions: {
            _functions: Map<string, import("@amodx/uri/Shaders/Types/ShaderData.types.js").ShaderFunctionData<any>>;
            _functionSets: Map<string, string[]>;
            create(id: string, data: import("@amodx/uri/Shaders/Types/ShaderData.types.js").ShaderFunctionData<any>): void;
            _processFunctinos(id: string, data: import("@amodx/uri/Shaders/Types/ShaderData.types.js").ShaderFunctionData<any>, shader?: URIShader | null): string;
            build(id: string, data?: import("@amodx/uri/Shaders/Types/ShaderData.types.js").ShaderFunctionData<any> | null, shader?: URIShader | null, predicate?: (id: string, type: import("@amodx/uri/Shaders/Types/ShaderData.types.js").ShaderFunctionData<any>) => boolean): string;
        };
        define: {
            _process(data: import("@amodx/uri/Shaders/Types/ShaderData.types.js").ShaderDefinesData): string;
            build(data: import("@amodx/uri/Shaders/Types/ShaderData.types.js").ShaderDefinesData | import("@amodx/uri/Shaders/Types/ShaderData.types.js").ShaderDefinesData[] | Map<string, import("@amodx/uri/Shaders/Types/ShaderData.types.js").ShaderDefinesData>): string;
        };
        constants: {
            _process(data: import("@amodx/uri/Shaders/Types/ShaderData.types.js").ShaderConstantData): string;
            build(data: import("@amodx/uri/Shaders/Types/ShaderData.types.js").ShaderConstantData | import("@amodx/uri/Shaders/Types/ShaderData.types.js").ShaderConstantData[] | Map<string, import("@amodx/uri/Shaders/Types/ShaderData.types.js").ShaderConstantData>): string;
        };
        uniforms: {
            _process(data: import("@amodx/uri/Shaders/Types/ShaderData.types.js").ShaderUniformData): string;
            build(data: import("@amodx/uri/Shaders/Types/ShaderData.types.js").ShaderUniformData[] | Map<string, import("@amodx/uri/Shaders/Types/ShaderData.types.js").ShaderUniformData>, predicate?: (id: string, type: import("@amodx/uri/Shaders/Types/ShaderData.types.js").ShaderUniformData) => boolean): string;
        };
        snippets: {
            _snippets: Map<string, import("@amodx/uri/Shaders/Types/ShaderData.types.js").ShaderSnippetData<any>>;
            create(data: import("@amodx/uri/Shaders/Types/ShaderData.types.js").ShaderSnippetData<any>): void;
            override(id: string, data: import("@amodx/uri/Shaders/Types/ShaderData.types.js").ShaderSnippetData<any>): boolean;
            get(id: string, args?: any): string;
            _process(text: string, shader?: URIShader): {
                newBody: string;
                foundSnippet: boolean;
            };
            build(text: string, shader?: URIShader): string;
        };
    };
}
