import { ShaderConstantData, ShaderDataTypes, ShaderVaryingData } from "@amodx/uri/Shaders/Types/ShaderData.types.js";
import { DVEShaderRegister } from "./DVEShaderRegister.js";
import { URIShader } from "@amodx/uri/Shaders/Classes/URIShader.js";
export declare const DVEShaders: {
    register: DVEShaderRegister;
    builder: {
        shaders: {
            _shaders: Map<string, URIShader>;
            create(id: string): URIShader;
        };
        functions: {
            _functions: Map<string, import("@amodx/uri/Shaders/Types/ShaderData.types.js").ShaderFunctionData<any>>;
            _functionSets: Map<string, string[]>;
            create(id: string, data: import("@amodx/uri/Shaders/Types/ShaderData.types.js").ShaderFunctionData<any>): void;
            _processFunctinos(id: string, data: import("@amodx/uri/Shaders/Types/ShaderData.types.js").ShaderFunctionData<any>, shader?: URIShader | null): string;
            build(id: string, data?: import("@amodx/uri/Shaders/Types/ShaderData.types.js").ShaderFunctionData<any> | null, shader?: URIShader | null, predicate?: (id: string, type: import("@amodx/uri/Shaders/Types/ShaderData.types.js").ShaderFunctionData<any>) => boolean): string;
        };
        define: {
            _process(data: import("@amodx/uri/Shaders/Types/ShaderData.types.js").ShaderDefinesData): string;
            build(data: import("@amodx/uri/Shaders/Types/ShaderData.types.js").ShaderDefinesData | import("@amodx/uri/Shaders/Types/ShaderData.types.js").ShaderDefinesData[] | Map<string, import("@amodx/uri/Shaders/Types/ShaderData.types.js").ShaderDefinesData>): string;
        };
        constants: {
            _process(data: ShaderConstantData): string;
            build(data: ShaderConstantData | ShaderConstantData[] | Map<string, ShaderConstantData>): string;
        };
        uniforms: {
            _process(data: import("@amodx/uri/Shaders/Types/ShaderData.types.js").ShaderUniformData): string;
            build(data: import("@amodx/uri/Shaders/Types/ShaderData.types.js").ShaderUniformData[] | Map<string, import("@amodx/uri/Shaders/Types/ShaderData.types.js").ShaderUniformData>, predicate?: (id: string, type: import("@amodx/uri/Shaders/Types/ShaderData.types.js").ShaderUniformData) => boolean): string;
        };
        snippets: {
            _snippets: Map<string, import("@amodx/uri/Shaders/Types/ShaderData.types.js").ShaderSnippetData<any>>;
            create(data: import("@amodx/uri/Shaders/Types/ShaderData.types.js").ShaderSnippetData<any>): void;
            override(id: string, data: import("@amodx/uri/Shaders/Types/ShaderData.types.js").ShaderSnippetData<any>): boolean;
            get(id: string, args?: any): string;
            _process(text: string, shader?: URIShader): {
                newBody: string;
                foundSnippet: boolean;
            };
            build(text: string, shader?: URIShader): string;
        };
    };
    voxelAttributes: [id: string, type: ShaderDataTypes][];
    voxelSharedUniforms: [id: string, type: ShaderDataTypes][];
    voxelVertexUniforms: [id: string, type: ShaderDataTypes][];
    voxelConstants: ShaderConstantData[];
    voxelVarying: ShaderVaryingData<any>[];
    voxelFragFunctions: string[];
    voxelVertexFunctions: string[];
    _defaultShader: URIShader;
    $INIT(): void;
    _addInstances(shader: URIShader): void;
    createVoxelShader(id: string): URIShader;
    createBasicTextureShader(id: string): URIShader;
    createSkyBoxShader(id: string): URIShader;
};
