import type { RemoteBinaryStruct } from "@amodx/binary/";
import type { LocationData } from "@divinevoxel/core/Math";
import { DimensionsRegister } from "../../../Data/World/DimensionsRegister.js";
import { LocationBoundTool } from "./LocationBoundTool.js";
import { Vector3Like, Vec3Array } from "@amodx/math";
export declare abstract class DataToolBase extends LocationBoundTool {
    struct: RemoteBinaryStruct;
    _c: ArrayBuffer | SharedArrayBuffer | DataView;
    _dimensionRegister: DimensionsRegister;
    constructor();
    getStructValue(id: string): number;
    setTagValue(id: string, value: number): boolean;
    getArrayTagValue(id: string, index: number): number;
    setArrayTagValue(id: string, index: number, value: number): number | void;
    setBuffer(buffer: ArrayBuffer | DataView | SharedArrayBuffer): void;
    getBuffer(): ArrayBuffer;
    getAsArrayBuffer(): ArrayBuffer;
    getBufferSize(): number;
    abstract loadIn(): boolean;
    loadInAt(x: number, y: number, z: number): boolean;
    loadInVec3Array(vec3: Vec3Array): boolean;
    loadInVec3(vec3: Vector3Like): boolean;
    loadInAtLocation(location: LocationData): boolean;
}
export declare abstract class EncodedPositionDataTool extends DataToolBase {
    position: {
        x: number;
        y: number;
        z: number;
    };
    constructor();
    getPositionData(): {
        x: number;
        y: number;
        z: number;
    };
    setPositionData(x: number, y: number, z: number): {
        x: number;
        y: number;
        z: number;
    };
    setDimensionId(dimensionId: string): void;
    getDimensionId(): string;
    getLocationData(): LocationData;
}
