var FloraAnimStates;
(function (FloraAnimStates) {
    FloraAnimStates[FloraAnimStates["Panel"] = 1] = "Panel";
    FloraAnimStates[FloraAnimStates["CrossPanel"] = 2] = "CrossPanel";
    FloraAnimStates[FloraAnimStates["Box"] = 3] = "Box";
})(FloraAnimStates || (FloraAnimStates = {}));
export class VoxelShaderData {
    static AnimationStats = {
        Flora: FloraAnimStates,
    };
    static LightMask = 0xffff;
    static AOMask = 0xf;
    static AnimationMask = 0xfff;
    static TextureIndexMax = 0xffff;
    static createTextureIndex(index1, index2) {
        let value = 0;
        value =
            (value & ~(this.TextureIndexMax << 0)) |
                ((index1 & this.TextureIndexMax) << 0);
        value =
            (value & ~(this.TextureIndexMax << 16)) |
                ((index2 & this.TextureIndexMax) << 16);
        return value;
    }
    static createAttribute(light, ao, animation) {
        let value = 0;
        value = (value & ~(this.LightMask << 0)) | ((light & this.LightMask) << 0);
        value = (value & ~(this.AOMask << 16)) | ((ao & this.AOMask) << 16);
        value =
            (value & ~(this.AnimationMask << 20)) |
                ((animation & this.AnimationMask) << 20);
        return value;
    }
}
