import type { Vector3Like, Vec3Array } from "@amodx/math";
export declare class Flat3DIndex {
    _position: {
        x: number;
        y: number;
        z: number;
    };
    bounds: {
        x: number;
        y: number;
        z: number;
    };
    getIndex(x: number, y: number, z: number): number;
    getXYZ(index: number): Vector3Like;
}
/**# Flat 3D Array
 * ---
 * Used to treat a number or typed array 1d array as a 3d array.
 */
export declare class Flat3DArray extends Flat3DIndex {
    bounds: Vector3Like;
    array: number[] | Uint8Array;
    volumne: number;
    constructor(bounds: Vector3Like);
    updateBounds(bounds: Vector3Like): void;
    setArray(array: number[] | Uint8Array): void;
    fillArray(value?: number): void;
    getValue(x: number, y: number, z: number): number;
    getValueUseObj(position: Vector3Like): number;
    setValue(x: number, y: number, z: number, value: number): void;
    setValueUseObj(position: Vector3Like, value: number): void;
    deleteValue(x: number, y: number, z: number): void;
    deleteUseObj(position: Vector3Like): void;
}
/**# Flat 3D Any Array
 * ---
 * Used to treat a 1d array as a 3d array.
 */
export declare class Flat3DAnyArray<T> extends Flat3DIndex {
    array: T[];
    _position: {
        x: number;
        y: number;
        z: number;
    };
    volumne: number;
    constructor(bounds: Vec3Array, array: T[]);
    updateBounds(bounds: Vector3Like): void;
    setArray(array: T[]): void;
    getValue(x: number, y: number, z: number): T;
    setValue(x: number, y: number, z: number, value: T): void;
    deleteValue(x: number, y: number, z: number): void;
}
