import type { LocationData } from "@divinevoxel/core/Math";
import { RawVoxelData } from "@divinevoxel/core";
export declare class WorldGenRegister {
    static MAX_ATTEMPTS: number;
    static _requests: Map<string, {
        attempts: number;
        dimension: string;
        chunks: Map<string, [x: number, y: number, z: number]>;
        voxels: [x: number, y: number, z: number, data: RawVoxelData][];
    }>;
    static registerRequest(location: LocationData): string;
    static addToRequest(registerId: string, location: LocationData, rawData: RawVoxelData): false | undefined;
    static attemptRequestFullFill(registerId: string): boolean;
}
