import { Observable } from "@amodx/core/Observers";
import { LocationData } from "@divinevoxel/core/Math";
export declare abstract class DVEBuilder {
    static observers: {
        texturesRegistered: Observable<{
            textureDataHasBeenSet: boolean;
            data: import("../../Textures/Texture.types").TextureTypeUVMap;
            getTextureUV(data: import("../../Textures/Constructor.types").ConstructorTextureData, overlay?: boolean): number;
            setTextureIndex(data: import("../../Textures/Texture.types").TextureTypeUVMap): void;
            releaseTextureData(): void;
            isReady(): boolean;
        }>;
    };
    abstract init(): void;
    abstract buildChunk(location: LocationData, LOD: number, priority: number): void;
}
