import type { TextureData, TextureTypeUVMap } from "./Texture.types";
import { TextureType } from "./TextureType.js";
import { ConstructorTextureData } from "./Constructor.types";
export declare class TextureManager {
    static defaultTexturePath: string;
    static textureTypes: Map<string, TextureType>;
    static getTextureIndex(data: ConstructorTextureData, overlay?: boolean): number;
    static _ready: boolean;
    static isReady(): boolean;
    static $INIT(): Promise<void>;
    static $START_ANIMATIONS(): void;
    static generateTextureUVMap(): TextureTypeUVMap;
    static defineDefaultTexturePath(path: string): void;
    static getTextureData([type, id, segment]: ConstructorTextureData): TextureData | undefined;
    static getTextureType(id: string): false | TextureType;
    static getOrAddTextureType(id: string): TextureType;
    static addTextureType(id: string): TextureType;
    static clearTextureData(): void;
    static registerTexture(textureData: TextureData | TextureData[]): void;
    static getRaw([type, id, segment]: ConstructorTextureData): void;
    static createRawDataMap(): Promise<Map<string, Uint8ClampedArray>>;
}
