import type { Vec3Array } from "@amodx/math";
import { DataMatrix } from "./DataMatrix.js";
import { Flat3DIndex } from "@amodx/math/Volumes/Indexing/Flat3DIndex.js";
import { DataTool } from "../Default/Tools/Data/DataTool";
export declare class VoxelIDMatrix extends DataMatrix<string | number> {
    size: Vec3Array;
    static dataTool: DataTool;
    index: Flat3DIndex;
    constructor(size: Vec3Array);
    setBounds(size: Vec3Array): void;
    toFlatArray(): number[];
    toTypedArray(): Uint16Array;
    fromFlatArray(voxels: ArrayLike<number>): void;
    copy(matrix: VoxelIDMatrix): void;
}
